/**
 * Mobile Menu 0.0.2
 * Compose mobile menu module
 * @author Kyle Foster (@hkfoster)
 * @license MIT (http://www.opensource.org/licenses/mit-license.php/)
 **/

// Dependencies
var toolbox    = require( 'compose-toolbox' )

// Public API function
var mobileMenu = function( settings ) {

  // Overridable defaults
  var defaults = {
    initWidth  : '700px',
    openClass  : 'menu-open',
    nav        : '.main-nav',
    button     : '.mobile-menu-button'
  },

  // Scoped variables
  options    = toolbox.merge( defaults, settings ),
  selector   = options.button + ', ' + options.openClass + ' ' + options.nav + ' a',
  docBody    = document.body;

  // Attach listeners
  toolbox.event.on( document, 'click', selector, function() {
    // Toggle body class
    docBody.classList.toggle( options.openClass )
  })

}

// Public API
module.exports = mobileMenu
