// Shim modules
require( './shim/object_fit' );
require( './shim/scope' );

// Utility modules
var loadScript  = require( './utility/load_script' );
var toggler     = require('compose-toggler')
var once        = require('./utility/once')

// Base modules
var mobileMenu  = require( './base/mobilemenu' )
var form        = require( './base/form' )
var formUp      = require( 'compose-form-up' )
require( './base/sync-input-value' )

Object.assign( form, formUp )

// Enhancement modules
var waypoints   = require( './enhancement/waypoints' )
var notice      = require( './enhancement/notice' )
var sticky      = require( './enhancement/sticky' )
var modal       = require( './enhancement/modal' )
var lightbox    = require( './enhancement/lightbox' )
var collapse    = require( './enhancement/collapse' )
var smooth      = require( './enhancement/smooth-scroll' )
var esvg        = require( './_esvg' )
require( './_icons' )
require( './_topology' )
// var swap        = require( './enhancement/swap' );

// Vendor modules
var toolbox     = require( 'compose-toolbox' )
var event       = toolbox.event
var ajax        = require( 'superagent' )
var highlighter = require( 'compose-code-highlighter' )
var loader      = require( 'compose-loader' )

require( 'codemirror/mode/htmlmixed/htmlmixed' )
require( 'codemirror/mode/slim/slim' )
require( 'codemirror/mode/javascript/javascript' )
require( 'codemirror/mode/css/css' )
require( 'codemirror/mode/sql/sql' )
require( 'codemirror/mode/php/php' )
require( 'codemirror/mode/ruby/ruby' )
require( 'codemirror/mode/shell/shell' )
require( 'codemirror/mode/go/go' )
require( 'codemirror/mode/python/python' )
require( 'codemirror/mode/yaml/yaml' )
require( 'codemirror/mode/clike/clike' )
require( 'codemirror/addon/runmode/runmode' )
require( 'codemirror/addon/edit/matchbrackets' )

event.scroll.disablePointer()      // disable pointer events on scroll for performance (to avoid extra repaints)

// This seems to trigger animations whenever it is turned on again
// So I've disabled it for now
//event.resize.disableAnimation()    // disable animation on resize for performance (to avoid extra repaints)

// Trigger these events each time the page loads
event.change( function() {

  // Form module
  form()

  // Syntax highlighting
  highlighter.highlight()
});

// mobile accessiblity on sliders
// var rangeTouch = require('rangetouch')
// rangeTouch.set("thumbWidth", 20);  // Annoying hack to make input ranges work smoothly on touch devices

require('compose-slider')      // Our slider (range input) component

// Public API object
var ratchet = toolbox.merge( {
  loadScript  : loadScript,
  ajax        : ajax,
  loader      : loader,
  mobileMenu  : mobileMenu,
  form        : form,
  toggler     : toggler,
  once        : once,
  waypoints   : waypoints,
  notice      : notice,
  sticky      : sticky,
  modal       : modal,
  lightbox    : lightbox,
  collapse    : collapse,
  smooth      : smooth,
  esvg        : esvg
}, toolbox )

window.ratchet = module.exports = ratchet
