/**
 * LoadScript 0.0.1
 * Load external JavaScript function
 * @author Kyle Foster (@hkfoster)
 * @license MIT
 **/

// Public API function
var loadScript = function( url, callback ) {

  // Create a <script> element
  var script   = document.createElement( 'script' );

  // Make it async
  script.async = true;

  // Set source to passed URL
  script.src   = url;

  // Append it to document head
  document.head.appendChild( script );

  // Add load event listener
  script.addEventListener( 'load', function() {

    // And if a callback is passed, run it
    if ( callback ) callback();

  }, false );

};

// Public API
module.exports = loadScript;
