/**
 * Once 0.0.1
 * Create one-time events or functions
 * @author Kyle Foster (@hkfoster)
 * @license MIT
 **/

// Public API function
var once = {

  evt: function( target, type, listener, bubbles ) {

    // Create event
    target.addEventListener( type, function fn( event ) {

      // Remove event
      target.removeEventListener( type, fn, bubbles );

      // Call handler
      listener( event );

    }, bubbles );

  },

  fn: function( fn, context ) {
    var result;

    return function() {
      if ( fn ) {
        result = fn.apply( context || this, arguments );
        fn = null;
      }

      return result;
    };
  }

};

// Public API
module.exports = once;