Gem.loaded_specs['ratchet_design'].dependencies.each do |d|
  require d.name
end
require 'json'
require 'ratchet_design/version'

module RatchetDesign
  class Plugin < Cyborg::Plugin
  end
  
  class Helper < BlockHelpers::Base
  end

end

# Overridable site-level variables
module Site
  extend self

  # Default values
  mattr_accessor :name
  self.name = "Site name"

  mattr_accessor :title
  self.title = "Site title"

  # Map vars from app into engine
  def setup
    yield self
  end

  def config_data
    @config_data ||= Cyborg.config_data
  end

  def deployment_data
    config_data['deployments']
  end

  def deployment_icon
    @deployment_icon ||= Esvg.find_symbol('icons/deployment')
  end
end

Cyborg.register(RatchetDesign::Plugin, {
  gem: "ratchet_design",
  engine: "ratchet"
})
